R Pidugu

Solution For Error: " Current configuration of the parser doesn't allow a maxOccurs attribute value to be set greater than the value 5,000."


Currently I am working on a project where I need to transform Excel sheet data to an XML format in compliance with XSD given by my client.

When I am trying to parse the XSD using JAXB I got this error when doing mvn clean install.
Error: ""Current configuration of the parser doesn't allow a maxOccurs attribute value to be set greater than the value 5,000."

I found many solutions and route cause for this issue. You can find some information on Oracle site the route cause for the issue. It is because of the feature enabled for secure XML processing. This feature was enable in JAXP 1.3 which instructs parsers, transformers to behave in a secure fashion. You can find more information here: https://jaxp.java.net/1.4/JAXP-Compatibility.html#JAXP_security.

For me 2 solutions worked out:

Solution 1:
With code change or implemenetation:
//Create SchemaFactory using XSD file
SchemaFactory factory = SchemaFactory.newInstance(XMLConstants.W3C_XML_SCHEMA_NS_URI);
factory.setFeature(XMLConstants.FEATURE_SECURE_PROCESSING,false);
Schema schema = factory.newSchema(xsdSource);


Solution 2:


Another way is excluding the dependency of older version xerces jar that comes by default with in milyn-smooks-javabean jar and add dependency of newer version of xerces jar in pom.xml file of your project. Just like below.

.......
.........
<dependency>
            <groupId>org.milyn</groupId>
            <artifactId>milyn-smooks-javabean</artifactId>
            <version>1.5.1</version>
            <exclusions>

           <!---excluding older version of xerces that comes along with milyn jar by default -->
                <exclusion>
                    <groupId>xerces</groupId>
                    <artifactId>xercesImpl</artifactId>
                </exclusion>
            </exclusions>
    </dependency>

<!-- Adding the latest version of Xerces jar here -->
    <dependency>
        <groupId>xerces</groupId>
        <artifactId>xercesImpl</artifactId>
        <version>2.11.0</version>
    </dependency>


-------
---------

 I used the the 2nd solution worked perfectly. How about you?? Please let me know in comments section your way of solution for this issue. 

Subscribe to this Blog via Email :